;----------------------------------------------------------------------------
;///////////////////////// CODED BY Jung-Bum.CHOI. //////////////////////////
;----------------------------------------------------------------------------
                
                .MODEL SMALL, PASCAL
                .386c
                JUMPS
                INCLUDE MACRO.INC


FILESIZE        EQU 286336
FILEPARA        EQU FILESIZE / 16
FILEBLOC        EQU (FILESIZE / 1024) + 1


                .286
                CODE SEGMENT
                .386c
                ASSUME CS:CODE, DS:CODE
STARTOFF EQU    $
                ORG 2CH
ENVSEG   EQU    $
                ORG 100h

                Entry PROC NEAR
                MOV AX,OFFSET STACKBUFFER
                MOV SP,AX
                jmp InstallTSR
                

FONT_SEG        DW ?
FONT_NAME       DB 'JIS.FNT', 0
FONT_HANDLE     DW ?

EMM_ENTRY       DW ?, ?

EMM_HANDLE      DW ?

EMM_STRUC       DD FILESIZE
                DW 0
                DD 0
                DW 0
                DD 0


StoreHandler    21
StoreHandler    15
StoreHandler    10

MARK            DB 'CalZ-DosJv1.2-MarK'
MARK_LENGTH EQU $ - MARK               
OldInt10_LENGTH EQU $ - OldInt10
                Entry ENDP

                Int10Handler PROC FAR
                pusha
                push ds
                push es
                pushf
                push cs
                pop ds

                cmp ax,10ffh                    ; REQUEST XMM ADDRESS ?
                je returnxmm
                cmp ax,0072h                    ; DOS/V SET VIDEO MODE ?
                je vmode
                cmp ax,1800h                    ; READ FONT BLOCK ?
                jne another
                jmp getfont
returnxmm:
                popf
                pop es
                pop ds
                popa
                mov eax, dword ptr cs:[EMM_ENTRY]
                mov cx, word ptr cs:[EMM_HANDLE]
                iret
vmode:
                mov ax, 12h
                int 10h
                CLEAR AX
                mov es, ax
                mov byte ptr es:[449h], 72h
                popf
                pop es
                pop ds
                popa
                iret
another:
                popf
                pop es
                pop ds
                popa
                FJMP <OFFSET OldInt10>

;----------------------------------------------------------------------------
; CX = SJIS Code
; DX = Font Size (1010h, 0808h, 0810h, 0808h, 1818h, 2020h....)
; Thanks to Shiragatakehirokunioshiwakayamatoneko ^_^
;----------------------------------------------------------------------------
getfont:
                POPF

                CWDE

                MOV DWORD PTR [EMM_STRUC+00H], 32
                MOV WORD PTR [EMM_STRUC+0CH], SI
                MOV WORD PTR [EMM_STRUC+0EH], ES

                CMP DX, 1010H
                JZ LABEL_41
                CMP DX, 0810H
                JNZ FONT_END
                MOV DWORD PTR [EMM_STRUC+00H], 16

                XCHG AX, CX
                CMP AX, 00E0H
                JB LABEL_73
LABEL_41:       MOV AL, CH
                SUB AL, 81H
                CMP AL, 1EH
                JBE LABEL_4F
                CMP AL, 5FH
                JB LABEL_87
                SUB AL, 40H
LABEL_4F:       SUB CL, 40H
                JB LABEL_87
                CMP CL, 0BCH
                JA LABEL_87
                CMP CL, 3FH
                JZ LABEL_87
                JB LABEL_61
                DEC CX
LABEL_61:       MOV AH, 0BCH
                MUL AH
                MOV CH, 0
                ADD AX, CX
                CMP AX, 1117H
;               JAE LABEL_9C
                ADD AX, 70H
                ADD AX, AX

LABEL_73:       SHL EAX, 4
                MOV DWORD PTR [EMM_STRUC+06H], EAX

                MOVREG <AH:0BH, SI:OFFSET EMM_STRUC>
                CALL DWORD PTR [EMM_ENTRY]
                JMP FONT_END
LABEL_87:       MOV AH, 11H
LABEL_89:       MOV AL, DH
LABEL_8B:       MOV ES:[SI], AH
                INC SI
                SUB AL, 8
                JNZ LABEL_8B
                ROR AH, 1
                DEC DL
                JNZ LABEL_89

LABEL_9C:
FONT_END:       pop es
                pop ds
                popa
                iret
                Int10Handler ENDP


;---------------------------------------------------------------------------
OldInt15_LENGTH EQU $ - OldInt15
                Int15Handler PROC FAR
                pusha
                push ds
                push es
                pushf
                push cs
                pop ds

                cmp ax,5000h                    ; GET FONT FUNCTION'S ADDRESS
                jne another2                    ; (i only emul...read function)
                jmp getfont2
another2:
                popf
                pop es
                pop ds
                popa
                FJMP <OFFSET OldInt15>
getfont2:
                POPF
FONT_END2:      pop es
                mov ax, cs
                mov es, ax
                pop ds
                popa
                OR BH, BH
                JZ fonttt
                mov bx, offset FONT16x16
                JMP fonttttt
fonttt:
                mov bx, offset FONT8x16
fonttttt:
                mov ah, 0
                PUSH BP
                PUSH AX
                CMP DH, 16
                JA SIZE_NO
                CMP DL, 16
                JA SIZE_NO
                CLC
                PUSHF
                POP AX
                MOV BP, SP
                MOV [BP+8], AX
                POP AX
                POP BP
                iret
SIZE_NO:
                STC
                PUSHF
                POP AX
                MOV BP, SP
                MOV [BP+8], AX
                POP AX
                POP BP
                iret
                Int15Handler ENDP

;---------------------------------------------------------------------------
OldInt21_LENGTH EQU $ - OldInt21
                Int21Handler PROC FAR
                pusha
                push ds
                push es
                pushf
                push cs
                pop ds

                cmp ax,3800h
                jne another3
                jmp getfont3
another3:
                popf
                pop es
                pop ds
                popa
                FJMP <OFFSET OldInt21>
getfont3:
                POPF
                pop es
                pop ds
                popa

                pushf
                CALL DWORD PTR CS:[OldInt21]
                mov bx, 51h
                PUSH BP
                PUSH AX
                CLC
                PUSHF
                POP AX
                MOV BP, SP
                MOV [BP+8], AX
                POP AX
                POP BP
                iret
                Int21Handler ENDP

;---------------------------------------------------------------------------
                FONT16x16 PROC FAR
                PUSHA
                MOV AX, 1800H
                MOV DX, 1010H
                INT 10H
                POPA
                RETF
                FONT16x16 ENDP

;---------------------------------------------------------------------------
                FONT8x16 PROC FAR
                PUSHA
                MOV AX, 1800H
                MOV DX, 810H
                AND CX, 0FFH
                INT 10H
                POPA
                RETF
                FONT8x16 ENDP
;---------------------------------------------------------------------------
;               START!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;---------------------------------------------------------------------------
InstallTSR:
                CLEAR AX
                MOVREG <ES:AX, DI:WORD PTR ES:[10H*4]>
                MOVREG <ES:WORD PTR ES:[(10H*4)+2]>
                SUB DI, MARK_LENGTH
                MOVREG <SI:OFFSET MARK, CX:MARK_LENGTH>
                REPZ CMPSB
                JNZ INST_TSR
                AND CX, CX
                JNZ INST_TSR
                PUSH CS
                POP DS
                JMP REMOVTSR                             ;IF STAY
INST_TSR:

                MOVREG <AX:CS, ES:AX>
                INTCALL 21h, <AH:49H, BX:WORD PTR [ENVSEG], ES:BX>   ;DEL ENV
                PUSH DS
                INTCALL 21h, <AX:6300H>
                OR BYTE PTR DS:[SI], 0
                JNZ FONT_OKK
                MOV BYTE PTR DS:[SI], 0FFH
FONT_OKK:
                POP DS

                
                MOVREG <AX:CS, ES:AX>
                INTCALL 21h, <AH:4AH, BX:(ENDOFF - STARTOFF)/16 + 0FH>
                MOVREG <AX:CS, ES:AX>

                INTCALL 21h, <AX:4800H, BX:FILEPARA>
                JC ERROR1
                MOV [FONT_SEG], AX

                INTCALL 21h, <AX:3D00H, DX:OFFSET FONT_NAME>
                MOV [FONT_HANDLE], AX
                MOV BX, AX
                JC ERROR2

                MOV DS, [FONT_SEG]
READ_FONT:
                INTCALL 21h, <AX:3F00H, DX:0, CX:8000H>
                MOV SI, DS
                ADD SI, 800H
                MOV DS, SI
                OR AX, AX
                JNZ READ_FONT

                MOVREG <AX:CS, DS:AX>
                INTCALL 21h, <AX:3E00H, BX:[FONT_HANDLE]>

                INTCALL 2Fh, <AX:4300H>
                CMP AL, 80H
                JNZ ERROR3

                INTCALL 2Fh, <AX:4310H>
                MOV [EMM_ENTRY], BX
                MOV [EMM_ENTRY+2], ES

                MOVREG <AH:9, DX:FILEBLOC>
                CALL DWORD PTR [EMM_ENTRY]
                MOV [EMM_HANDLE], DX
                OR AX, AX
                JZ ERROR4

                MOV AX, [FONT_SEG]
                MOV WORD PTR [EMM_STRUC+08H], AX
                MOV WORD PTR [EMM_STRUC+0AH], DX

                MOVREG <AH:0BH, SI:OFFSET EMM_STRUC>
                CALL DWORD PTR [EMM_ENTRY]


                MOV AX, [EMM_HANDLE]
                MOV DWORD PTR [EMM_STRUC+00H], 32
                MOV  WORD PTR [EMM_STRUC+04H], AX
                MOV DWORD PTR [EMM_STRUC+06H], 0
                MOV  WORD PTR [EMM_STRUC+0AH], 0

                INTCALL 21h, <AX:4900H, ES:[FONT_SEG]>
                MOVREG <AX:CS, ES:AX>

                GETVECT OldInt10, 10h
                GETVECT OldInt15, 15h
                GETVECT OldInt21, 21h
               
                DSETVECT 10h, Int10Handler
                DSETVECT 15h, Int15Handler
                DSETVECT 21h, Int21Handler

                INTCALL 21h, <AH:09h, DX:OFFSET InstallOK>
                INTCALL 21h, <AX:3100H, DX:(InstallTSR-STARTOFF)/16+0FH>
REMOVTSR:

                INTCALL 10h, <AX:10FFH>

                MOV DWORD PTR CS:[EMM_ENTRY], EAX
                MOV WORD PTR CS:[EMM_HANDLE], CX
                CLEAR AX
                MOVREG <ES:AX, DI:WORD PTR ES:[10H*4]>
                MOVREG <ES:WORD PTR ES:[(10H*4)+2]>  ;ES:SI=Int10Handler PROC
                SUB DI, OldInt10_LENGTH
                MOVREG <AX:ES:[DI], BX:ES:[DI+2]
                MOV WORD PTR [OldInt10], AX
                MOV WORD PTR [OldInt10+2], BX
                MSETVECT 10h, OldInt10               ;RESTORE OldInt10

                CLEAR AX
                MOVREG <ES:AX, DI:WORD PTR ES:[21H*4]>
                MOVREG <ES:WORD PTR ES:[(21H*4)+2]>  ;ES:SI=Int21Handler PROC
                SUB DI, OldInt21_LENGTH
                MOVREG <AX:ES:[DI], BX:ES:[DI+2]
                MOV WORD PTR [OldInt21], AX
                MOV WORD PTR [OldInt21+2], BX
                MSETVECT 21h, OldInt21               ;RESTORE OldInt21

                CLEAR AX
                MOVREG <ES:AX, DI:WORD PTR ES:[15H*4]>
                MOVREG <ES:WORD PTR ES:[(15H*4)+2]>  ;ES:SI=Int15Handler PROC
                PUSH ES
                SUB DI, OldInt15_LENGTH
                MOVREG <AX:ES:[DI], BX:ES:[DI+2]
                MOV WORD PTR [OldInt15], AX
                MOV WORD PTR [OldInt15+2], BX
                MSETVECT 15h, OldInt15               ;RESTORE OldInt15
                POP ES
                INTCALL 21h, <AH:49H>                ;DEL STAY

                PUSH CS
                POP DS

                MOVREG <AH:0AH, DX:[EMM_HANDLE]>
                CALL DWORD PTR [EMM_ENTRY]

                INTCALL 21h, <AH:09h, DX:OFFSET UnInstallOK>
                EXIT

ERROR1:
                INTCALL 21h, <AH:09h, DX:OFFSET MES_ERROR1>
                EXIT
ERROR2:
                INTCALL 21h, <AX:4900H, ES:[FONT_SEG]>
                INTCALL 21h, <AH:09h, DX:OFFSET MES_ERROR2>
                EXIT
ERROR3:
                INTCALL 21h, <AX:4900H, ES:[FONT_SEG]>
                INTCALL 21h, <AH:09h, DX:OFFSET MES_ERROR3>
                EXIT
ERROR4:
                INTCALL 21h, <AX:4900H, ES:[FONT_SEG]>
                INTCALL 21h, <AH:09h, DX:OFFSET MES_ERROR4>
                EXIT
ERROR5:
                INTCALL 21h, <AX:4900H, ES:[FONT_SEG]>
                MOVREG <AH:0AH, DX:[EMM_HANDLE]>
                CALL DWORD PTR [EMM_ENTRY]
                INTCALL 21h, <AH:09h, DX:OFFSET MES_ERROR4>
                EXIT

InstallOK       DB 0DH
                DB 'Dos-J Plus Ver. 1.2s [MJ]',0Dh, 0Ah
                DB 'Installed.', '$'
UnInstallOK     DB 0DH
                DB 'Dos-J Plus Ver. 1.2s [MJ]',0Dh, 0Ah
                DB 'Uninstalled.', '$'
MES_ERROR1      DB 'not enough base memory!',0Dh, 0Ah, '$'
MES_ERROR2      DB 'JIS.FNT file not found!',0Dh, 0Ah, '$'
MES_ERROR3      DB 'XMS memory not found!',0Dh, 0Ah, '$'
MES_ERROR4      DB 'not enough XMS memory!',0Dh, 0Ah, '$'

NULL DW 1024 DUP (0)
STACKBUFFER DD 0
ENDOFF  EQU     $
                CODE ENDS
                END Entry
;----------------------------------------------------------------------------
